/**
 *  ~~ dPlayer.php  V 4.0  ~~
 *
 *  Part of - dPlayer -
 *  HTML5 Dynamic-Audio Player with Auto-Playlist
 *
 *  Copyright Kirk Siqveland 2022
 *
 *  HTML5 Dynamic-Audio Player with Auto-Playlist
 *
 *
 *
 **/

var audio            ; // define later as HTML5 audio object...

    
                /**  D I Y  **/
function KBSliderCallBack(ID, Progress, Pixels = -1, maxPixels = -1, source = "click"){
// Add your Code to respond to slider Changes Here:
  // console.log( "KBSlider Callback: ID = " + ID + " | Progress = " + Progress ) ;
  // console.log( "Pixels = " + Pixels + " of " + maxPixels   ) ;

  switch(ID){
    case "volume":
        audio.volume = Progress/100 ;
        // console.log( "KBSlider Callback: volume = " + audio.volume ) ;
        break ;
    case "songbar":
        // console.log( "KBSlider Callback: audio.duration = " + audio.duration ) ;    
        let setTime = parseInt(audio.duration*Progress/100) ;
        audio.currentTime = setTime                         ; 
        break ;
  }

}


document.addEventListener("DOMContentLoaded", function() {
    // Show the dPlayer and hide the "No JS" Message
        var nojsmsg = document.getElementsByClassName('nojsmsg')[0]    ;
            nojsmsg.classList.add('hidden')    ;
        var dPlayer = document.getElementsByClassName('player')[0]     ;
            dPlayer.classList.remove('hidden') ;        

    var tick     ;    // General use increment
    var useMP3      = true            ;
    // var audio                        ; // moved definition to KBSlider.js
    var pegCur      = 0               ;
    var pegNext     = 1               ;
    var pegPrev     = 0               ;
    var playing     = 0               ;
    var playlisting = 0               ;
    var opacity     = 0               ;
    var intervalID  = 0               ;
    var playItems   = 'wavItem'         ;

    var wavFiles    = document.getElementsByClassName('wavItem')    ;
    var mp3Files    = document.getElementsByClassName('mp3Item')    ;
    var listitems   = document.getElementsByClassName('mp3Item')    ;

    var playbtn     = document.getElementsByClassName('play')[0]     ;
    var pausebtn    = document.getElementsByClassName('pause')[0]    ;   
    var prevbtn     = document.getElementsByClassName('prev')[0]     ;
    var rewbtn      = document.getElementsByClassName('rew')[0]      ;
    var fwdbtn      = document.getElementsByClassName('fwd')[0]      ;
    var showpl      = document.getElementsByClassName('pl')[0]       ;

    var toggles     = document.getElementsByClassName('toggles')[0]  ;
    var mp3onbtn    = document.getElementsByClassName('mp3on')[0]    ;
    var wavonbtn    = document.getElementsByClassName('wavon')[0]    ;
    var mp3offbtn   = document.getElementsByClassName('mp3off')[0]   ;
    var wavoffbtn   = document.getElementsByClassName('wavoff')[0]   ;

    var audiolist   = ''   ;
    // var bugWatch = document.getElementsByClassName("debugger")[0] ;
    //     e.g. bugWath.innerHTML += "Some debug message...</br>"    ;


    if( useMP3 === false || listitems.length === 0){ 
            useMP3      = false             ;
            toggles.classList.add('hidden') ; 
            listitems   = document.getElementsByClassName('wavItem')    ;                
            audiolist   = document.getElementsByClassName('wavlist')[0] ;
    }else{ 
            audiolist   = document.getElementsByClassName('mp3list')[0] ; 
    }    

    if(listitems.length === 0){
        console.log("No files found!") ;
        return 0;
    }    
    
    wavonbtn.classList.add('hidden')   ;   
    mp3offbtn.classList.add('hidden')  ;

// -------------------------------------------------------------------------

    function initAudio(PLindex) {

        var peg         = parseInt(PLindex)         ;
        var liCount     = listitems.length          ;
        // console.log ("initiAudio -- Peg: "+ peg + " - of " + liCount)    ;
        // console.log ("initiAudio -- useMP3: "+ useMP3) ;

            if(PLindex == 0){
                pegCur  = 0                         ;
                pegNext = 1                         ;
                pegPrev = (liCount - 1).valueOf()   ;
            }else if (peg >= liCount){
                pegCur  = 0                         ;
                pegNext = 1                         ;
                pegPrev = (liCount - 1).valueOf()   ;            
            }else if (peg < 0){
                pegCur  = (liCount - 1).valueOf()   ;
                pegNext = 0                         ;
                pegPrev = (liCount - 2).valueOf()   ;
            }else{
                pegCur  = peg                       ;
                pegNext = (peg + 1).valueOf()       ;
                pegPrev = (peg - 1).valueOf()       ;               
            }
        var url         = pegAttrib('audiourl', pegCur) ;
        // var title       = pegAttrib('title', pegCur)    ;
        var displayname = pegAttrib('displayname', pegCur)    ;
        var subtitle    = pegAttrib('subtitle', pegCur) ;
        var album       = pegAttrib('album', pegCur)    ;
        var cover       = pegAttrib('cover', pegCur)    ;

                
        setText('title', displayname)                         ;
        setText('subtitle', subtitle)                   ;
        setText('album', album)                         ;
        document.getElementsByClassName("cover")[0].style.backgroundImage = "url('" + cover + "')" ;
        document.getElementById("splash").src = cover ;

        try {audio.removeEventListener("ended", rollNextAudio)      ; }
        catch(err) {console.log("Audio.eListener no 'ended' event") ; }

        // console.log("pegCur = " + pegCur + " - pegPrev = " + pegPrev + " - pegNext = " + pegNext) ;
        for (var tick = 0; tick < listitems.length; tick++) 
        {   listitems[tick].classList.remove("active")              ; }
            listitems[pegCur].classList.add('active')   ;

        audio = new Audio(url)                          ;
        audio.addEventListener('timeupdate',cbPlayTime) ;
        audio.addEventListener('loadedmetadata', function () {
            if(playing == 1){ playAudio() ; }
        });

    } //end - initAudio()myprogbox.style.opacity = "0.8" ;

    function rollNextAudio(){        
        initAudio(pegNext)                                  ;
    }    

    function cbPlayTime(){
        let curtime = audio.currentTime                         ; 
        let pbRatio = parseInt(curtime / audio.duration * 100)  ;
        SetProgress("songbar", pbRatio) ;
    }

    function playAudio() {
        audio.addEventListener('ended', rollNextAudio, false) ;
        audio.play()                                        ;
        playing = 1                                         ;
            playbtn.classList.add('hidden')                 ;
            pausebtn.classList.add('visible')               ;
    }

    function stopAudio() {
        audio.pause()                                       ;
        playing = 0                                         ;
            playbtn.classList.remove('hidden')              ;
            pausebtn.classList.remove('visible')            ;
    }

    function pauseAudio() {
        audio.pause()                                       ;
            playbtn.classList.remove('hidden')              ;
            pausebtn.classList.remove('visible')            ;
    }


      function swap2wav(){
            // Show
            wavonbtn.classList.remove('hidden')             ;
            wavonbtn.classList.add('visible')               ;  
            mp3offbtn.classList.remove('hidden')            ;
            mp3offbtn.classList.add('visible')              ;

            // Hide
            mp3onbtn.classList.remove('visible')            ;
            mp3onbtn.classList.add('hidden')                ;
            wavoffbtn.classList.remove('visible')           ;
            wavoffbtn.classList.add('hidden')               ;
            playItems  = 'wavItem'                          ;
            useMP3 = false ;
            
                if(playlisting == 1){                     
                    listitems  = document.getElementsByClassName('mp3Item') ;
                        for (var tick = 0; tick < listitems.length; tick++) 
                        {   listitems[tick].classList.remove("active")      ; }
                    listitems  = document.getElementsByClassName('wavItem') ;
                    listitems[pegCur].classList.add('active')               ;

                    audiolist.classList.remove('visible')     ;
                    audiolist.classList.add('hidden')         ; 
                    audiolist  = document.getElementsByClassName('wavlist')[0]  ;                    
                    audiolist.classList.remove('hidden')      ;
                    audiolist.classList.add('visible')        ;                     
                }             
            // window.location.reload(true)                ;
        }
        function swap2mp3(){
            // Show
            mp3onbtn.classList.remove('hidden')            ;
            mp3onbtn.classList.add('visible')              ;
            wavoffbtn.classList.remove('hidden')           ;
            wavoffbtn.classList.add('visible')             ; 

            // Hide
            wavonbtn.classList.remove('visible')           ;
            wavonbtn.classList.add('hidden')               ;  
            mp3offbtn.classList.remove('visible')          ;
            mp3offbtn.classList.add('hidden')              ;          
            playItems  = 'mp3Item'                         ;
            useMP3 = true ;

                if(playlisting == 1){       
                    listitems  = document.getElementsByClassName('wavItem')  ;
                    for (var tick = 0; tick < listitems.length; tick++) 
                    {   listitems[tick].classList.remove("active")           ; }
                    listitems  = document.getElementsByClassName('mp3Item')  ;
                    listitems[pegCur].classList.add('active')                ;

                    audiolist.classList.remove('visible')     ;
                    audiolist.classList.add('hidden')         ;
                    audiolist  = document.getElementsByClassName('mp3list')[0]  ;
                    audiolist.classList.remove('hidden')      ;
                    audiolist.classList.add('visible')        ;                      
                }              
        }    

    // show playlist
        function showPlaylist(){
            if(playlisting == 0){
                audiolist.style.opacity = 0               ;
                audiolist.classList.remove('hidden')      ;
                audiolist.classList.add('visible')        ;                
                intervalID  = setInterval(fadeInPL, 60)   ;
                playlisting = 1                           ;
            }else{      
                intervalID  = setInterval(fadeOutPL, 40)  ;
                playlisting = 0                           ;
            }            
        }     

    // Return Attributes of a specific Play List Item
       function pegAttrib(AttribName, peg = 0){
            var listpeg     = parseInt(peg) ;
            // var listitems   = document.getElementsByClassName(playItems)   ;
            if(listitems.length > 0){
                return listitems[listpeg].getAttribute(AttribName) ;
            }else{
                return "" ;
            }
        }

        function setText(ClassName, newText) {
            document.getElementsByClassName(ClassName)[0].innerHTML = newText ; 
        }   

        function fadeOutPL(){
          opacity = Number(window.getComputedStyle(audiolist).getPropertyValue("opacity")) ;
            if(opacity > 0){
                opacity = opacity - 0.1                 ;
                audiolist.style.opacity = opacity       ;
            }else{
                clearInterval(intervalID)               ;
                audiolist.classList.remove('visible')   ;
                audiolist.classList.add('hidden')       ;  
            }
        }  
        function fadeInPL(){
          opacity = Number(window.getComputedStyle(audiolist).getPropertyValue("opacity")) ;
            if(opacity < 1){
                opacity = opacity + 0.1                 ;
                audiolist.style.opacity = opacity       ;
            }else{
                clearInterval(intervalID)               ;
            }
        }

 /* -------------------------------------------------------------/
                Main Procedures - Setup UI events
/--------------------------------------------------------------*/
    // play click
        playbtn.addEventListener("click", function(e){
            e.preventDefault()                       ;
            playAudio()                              ;
        });

    // pause click
        pausebtn.addEventListener("click", function(e){
            e.preventDefault()                        ;
            stopAudio()                               ;            
        });

    // previous click
        prevbtn.addEventListener("click", function(e){     
            e.preventDefault()                       ;
            pauseAudio()                             ;
            initAudio(pegPrev)                       ;
            SetProgress("songbar", 0)                ;
        });

    // rewind click
        rewbtn.addEventListener("click", function(e){     
            e.preventDefault()                      ;
            pauseAudio()                            ;
            initAudio(pegCur)                       ;
            SetProgress("songbar", 0)               ;
        });

    // forward click
        fwdbtn.addEventListener("click", function(e){
            e.preventDefault()                      ;
            pauseAudio()                            ;
            initAudio(pegNext)                      ;
            SetProgress("songbar", 0)               ;
        });

  
    // add on-mp3button click
        mp3onbtn.addEventListener( "click", swap2wav, false ) ;
        wavoffbtn.addEventListener("click", swap2wav, false ) ;
    // add on-wavbtn click
        wavonbtn.addEventListener( "click", swap2mp3, false ) ;
        mp3offbtn.addEventListener("click", swap2mp3, false ) ;

        showpl.addEventListener("click", showPlaylist) ;

    // playlist elements -
    // Create function variables to use for  click & double-click
            var loadFile = function() {
                var peg = this.getAttribute("peg") ;
                pauseAudio()                    ;
                initAudio(peg)                  ;
            };

            var playFile = function() {
                var peg = this.getAttribute("peg") ;
                pauseAudio()                    ;
                playing = 1                     ;
                initAudio(peg)                  ;          
            };  
    // Add Click and Double-Click evnts to the wav List Items  
        var wavLI = document.getElementsByClassName('wavItem')  ;        
        for (tick = 0; tick < wavLI.length; tick++) {
            wavLI[tick].addEventListener('click',    loadFile, false)   ;
            wavLI[tick].addEventListener('dblclick', playFile, false)   ;
        }
        
    // Add Click and Double-Click evnts to the mp3 List Items        
        var mp3LI = document.getElementsByClassName('mp3Item')  ;        
        for (tick = 0; tick < mp3LI.length; tick++) {
            mp3LI[tick].addEventListener('click',    loadFile, false)   ;
            mp3LI[tick].addEventListener('dblclick', playFile, false)   ;
        }           
      
    // initialization - first element in playlist
        initAudio( 0 ) ;       

        InitProgress("songbar") ;
        InitProgress("volume" ) ; 

        SetProgress("songbar", 0 ) ;
        SetProgress("volume", 80 ) ;
        audio.volume = 0.8 ;

    //Start KBSlider functions for Volume:
        setSliderDrag("volume",true) ;  

}) ;

